// CRW - New
#pragma once

#include "platform/Tickable.h"

#include <map>
#include <string>
using namespace std;

struct mg_connection;
struct mg_server;
class WebServer : public virtual Tickable
{
protected:
  static WebServer* theWebServer;

  static char* replaceNullWithEmpty(const char* str) {
    return str==nullptr?"":str;
  }
  static int requestHandler(struct mg_connection* conn);
  static int connUpdateHandler(struct mg_connection* conn);
public:
  static WebServer* webServer();

  void startServer(string& webRoot, string& listenPort);
  void stopServer();
  
  string webServerURL();
  bool sendDataToConnection(string& clientIP, const char* data);
  void closeConnection(string& clientIP);

  virtual void interpolateTick( F32 delta );
  virtual void processTick() { }
  virtual void advanceTime( F32 timeDelta ) {}
private:
  WebServer() : mMongooseServer(nullptr) {}
  struct mg_server *mMongooseServer;
  struct connData {
    string clientIP;
    long lastUpdate;
    bool disconnected;
  };
  map<struct mg_connection *, connData> mWebSocketConnections;
};