ConsoleFunction(StartWebServer, void, 1, 3, "([directory], [port])")
{
  string root = "web";
  if ( argc > 1 )
    root = argv[1];
  string port = "8080";
  if ( argc > 2 )
    port = argv[2];
  WebServer::webServer()->startServer(root, port);
}

ConsoleFunction(StopWebServer, void, 1, 1, "()")
{
  WebServer::webServer()->stopServer();
}

ConsoleFunction(SendWebsocketMessage, bool, 3, 3, "(clientIP, message)")
{
  // DEBUG IN EMERGENCIES, OCCASIONALLY LAGS GAME:  Con::printf( "SendWebsocketMessage to [%s]:[%s]", argv[1], argv[2] );
  // Lookup the connection
  return WebServer::webServer()->sendDataToConnection(string(argv[1]), argv[2]);
}

ConsoleFunction(DisconnectWebsocketClient, void, 2, 2, "(clientIP)")
{
  return WebServer::webServer()->closeConnection(string(argv[1]));
}

ConsoleFunction(WebServerURL, const char*, 1, 1, "()")
{
  return Con::getReturnBuffer(WebServer::webServer()->webServerURL().c_str());
}